/*
 * JPA entity template
 *
 *
 * Takatuka - Template fuer JPA2 Entitaeten (inklusive Bean Validation)
 *
 * Moeglichkeiten und Einschraenkungen:
 * - Beziehungen werden abgebildet
 * -- es gibt keine 1:1 Beziehungen
 * -- N:M Beziehungen sind immer bidirektional
 * - Vererbung wird nicht unterstuetzt
 * - Support für CustomData
 */
package de.ivu.elect.business.unterstuetzer.entity;

@javax.persistence.NamedQueries(
 {



   
      @javax.persistence.NamedQuery(
     name="EINTRAGUNGSLISTE_EINTRAG.MaxPosition",
     query="SELECT MAX(obj.position) FROM EintragungslisteEintrag obj WHERE obj.gueltigkeit NOT IN (?3) AND obj.eintragungsliste.wahlvorschlag = ?1 AND obj.eintragungsliste.nummer = ?2",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "false"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

                
         ,   @javax.persistence.NamedQuery(
     name="EINTRAGUNGSLISTE_EINTRAG.WahlAndWildcardNummerGroupedByEintragungslisteAndGueltigkeit",
     query="SELECT el.id, el.nummer, ele.gueltigkeit, COUNT(ele.id) FROM EintragungslisteEintrag ele JOIN ele.eintragungsliste el WHERE el.wahlvorschlag.gruppeImGebiet.gebiet.wahl = ?1 AND STR(el.nummer) LIKE ?2 GROUP BY el.id, el.nummer, ele.gueltigkeit",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "false"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

                
     }
)
@javax.enterprise.inject.Vetoed
@javax.persistence.Entity
@javax.persistence.Table(name = "EINTRAGUNGSLISTE_EINTRAG")
// @javax.persistence.IdClass(EintragungslisteEintragPK.class)
    @javax.persistence.EntityListeners(de.ivu.elect.jee.protokollierung.ProtokollEntityListener.class)
    
public
 class EintragungslisteEintrag
extends AbstractEintragungslisteEintrag
  {

  private static final long serialVersionUID = 0L;


  /**
   * default constructor
   */
  public EintragungslisteEintrag() {
    super();
  }

    /**
     * @param original
     *
     * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
     *             als Deprecated.
     */
    @Deprecated
    public EintragungslisteEintrag(EintragungslisteEintrag original){
      original.copyEntity(this);
    }

  /**
   * PRIMARY KEY
   */
  @javax.persistence.Id
  @javax.persistence.Column(name = "eintragungsliste_eintrag_id")
    @javax.persistence.GeneratedValue(strategy = javax.persistence.GenerationType.TABLE, generator = "EintragungslisteEintrag")
    @javax.persistence.TableGenerator(name = "EintragungslisteEintrag", table = "SEQUENCES", pkColumnName = "sequence_name", pkColumnValue = "EintragungslisteEintrag", valueColumnName = "next_val", allocationSize = 1000, initialValue = 0)
    protected java.lang.Long id;

  @Override
  public java.lang.Long getId() {
    return id;
  }

  public void setId(java.lang.Long id) {
    this.id = id;
  }

  @javax.persistence.Transient
  private transient EintragungslisteEintragPK pkCache;

  @Override
  public EintragungslisteEintragPK getPk() {
    if (pkCache==null || pkCache.getId() != id ) {
      pkCache = new EintragungslisteEintragPK(getId());
    }

    return pkCache;
  }

  public static <E extends EintragungslisteEintrag> java.util.Map<EintragungslisteEintragPK, E> mappeNachPk(java.util.Collection<E> entities){
    java.util.Map<EintragungslisteEintragPK, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getPk(), entity);
    }

    return result;
  }

  public static <E extends EintragungslisteEintrag> java.util.Map<Long, E> mappeNachId(java.util.Collection<E> entities){
    java.util.Map<Long, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getId(), entity);
    }

    return result;
  }



  /**
   * Indikator, ob sich ein Attribut oder eine UNIDIREKTIONALE n:1-Beziehungen geaendert hat
   */
  @javax.persistence.Transient
  protected boolean attributeChanged = false;

  public void setAttributeChanged() {
    attributeChanged = true;
  }

  public boolean isAttributeChanged() {
    return attributeChanged;
  }

  /**
   * Hilfsvariable fuer das Aktualisieren von Beziehungen
   */
  @javax.persistence.Transient
  protected boolean updateRelationship = false;


  public void resetAttributeChanged() {
        hasChangedErfassungZeitpunkt = false;
          hasChangedGueltigkeit = false;
          hasChangedPosition = false;
  
    


    attributeChanged = false;
  }


  /**
   * ATTRIBUTE
   */

    
  @javax.persistence.Temporal(javax.persistence.TemporalType.TIMESTAMP)
  @javax.persistence.Column(name = "ERFASSUNG_ZEITPUNKT", nullable = EintragungslisteEintragConstants.ERFASSUNG_ZEITPUNKT_NULLABLE, precision=EintragungslisteEintragConstants.ERFASSUNG_ZEITPUNKT_PRECISION)
    
  protected java.util.Date erfassungZeitpunkt =  null;

  @javax.persistence.Transient
  protected boolean hasChangedErfassungZeitpunkt = false;

  public boolean hasChangedErfassungZeitpunkt(){
    return hasChangedErfassungZeitpunkt;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertErfassungZeitpunkt = false;
     @javax.persistence.Transient
     private transient java.util.Date wertNachLadenErfassungZeitpunkt;
  
  /**
   * 
   *
   * getter for EINTRAGUNGSLISTE_EINTRAG.ERFASSUNG_ZEITPUNKT
   */
  @javax.annotation.Nullable   @Override   public  java.util.Date getErfassungZeitpunkt() {
              if (erfassungZeitpunkt == null){
            return null;
          } else {
                          return erfassungZeitpunkt;
          }
      }

  /**
   * 
   *
   * setter for EINTRAGUNGSLISTE_EINTRAG.ERFASSUNG_ZEITPUNKT
   *
   * @param erfassungZeitpunkt
   */
  @Override   public void setErfassungZeitpunkt(@javax.annotation.Nullable  java.util.Date erfassungZeitpunkt) {

       resetTkCache();
                  java.util.Date erfassungZeitpunktInternal = de.ivu.elect.jee.entity.EntityUtil.normalizeDateTime(erfassungZeitpunkt);
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.erfassungZeitpunkt
      , erfassungZeitpunktInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedErfassungZeitpunkt |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("erfassungZeitpunkt");
      }


             if (!isSeitLadenVeraendertErfassungZeitpunkt) {
          isSeitLadenVeraendertErfassungZeitpunkt = thisAttributChanged;
         if (isSeitLadenVeraendertErfassungZeitpunkt){
           wertNachLadenErfassungZeitpunkt=this.erfassungZeitpunkt;
         }
       }
      

       this.erfassungZeitpunkt = erfassungZeitpunktInternal;

         }

        
    @javax.persistence.Enumerated(javax.persistence.EnumType.STRING)
      @javax.persistence.Column(name = "GUELTIGKEIT", nullable = EintragungslisteEintragConstants.GUELTIGKEIT_NULLABLE)
    
  protected de.ivu.elect.business.unterstuetzer.entity.EintragungslisteEintragGueltigkeit gueltigkeit =  de.ivu.elect.business.unterstuetzer.entity.EintragungslisteEintragGueltigkeit.UNBEKANNT;

  @javax.persistence.Transient
  protected boolean hasChangedGueltigkeit = false;

  public boolean hasChangedGueltigkeit(){
    return hasChangedGueltigkeit;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertGueltigkeit = false;
     @javax.persistence.Transient
     private transient de.ivu.elect.business.unterstuetzer.entity.EintragungslisteEintragGueltigkeit wertNachLadenGueltigkeit;
  
  /**
   * 
   *
   * getter for EINTRAGUNGSLISTE_EINTRAG.GUELTIGKEIT
   */
    @Override   public  de.ivu.elect.business.unterstuetzer.entity.EintragungslisteEintragGueltigkeit getGueltigkeit() {
        return gueltigkeit;
      }

  /**
   * 
   *
   * setter for EINTRAGUNGSLISTE_EINTRAG.GUELTIGKEIT
   *
   * @param gueltigkeit
   */
  @Override   public void setGueltigkeit( de.ivu.elect.business.unterstuetzer.entity.EintragungslisteEintragGueltigkeit gueltigkeit) {

       resetTkCache();
                  de.ivu.elect.business.unterstuetzer.entity.EintragungslisteEintragGueltigkeit gueltigkeitInternal = gueltigkeit;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.gueltigkeit
      , gueltigkeitInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedGueltigkeit |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("gueltigkeit");
      }


             if (!isSeitLadenVeraendertGueltigkeit) {
          isSeitLadenVeraendertGueltigkeit = thisAttributChanged;
         if (isSeitLadenVeraendertGueltigkeit){
           wertNachLadenGueltigkeit=this.gueltigkeit;
         }
       }
      

       this.gueltigkeit = gueltigkeitInternal;

         }

        
      @javax.persistence.Column(name = "POSITION", nullable = EintragungslisteEintragConstants.POSITION_NULLABLE, precision=EintragungslisteEintragConstants.POSITION_PRECISION, scale=EintragungslisteEintragConstants.POSITION_SCALE)
            
  protected java.lang.Long position =  Long.valueOf("1");

  @javax.persistence.Transient
  protected boolean hasChangedPosition = false;

  public boolean hasChangedPosition(){
    return hasChangedPosition;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertPosition = false;
     @javax.persistence.Transient
     private transient java.lang.Long wertNachLadenPosition;
  
  /**
   * 
   *
   * getter for EINTRAGUNGSLISTE_EINTRAG.POSITION
   */
    @Override   public  java.lang.Long getPosition() {
        return position;
      }

  /**
   * 
   *
   * setter for EINTRAGUNGSLISTE_EINTRAG.POSITION
   *
   * @param position
   */
  @Override   public void setPosition( java.lang.Long position) {

       resetTkCache();
                  java.lang.Long positionInternal = position;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.position
      , positionInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedPosition |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("position");
      }


             if (!isSeitLadenVeraendertPosition) {
          isSeitLadenVeraendertPosition = thisAttributChanged;
         if (isSeitLadenVeraendertPosition){
           wertNachLadenPosition=this.position;
         }
       }
      

       this.position = positionInternal;

         }

    
/**
 * Beziehungen N:1 unidirektional
 */

/**
 * Beziehungen N:1 bidirektional
 */
  /**
   * Beziehung N:1 (bidirektional) zu Eintragungsliste
   */
  @javax.persistence.ManyToOne(fetch =  javax.persistence.FetchType.LAZY , optional=false, cascade = {javax.persistence.CascadeType.PERSIST})
  @javax.persistence.JoinColumns(@javax.persistence.JoinColumn(name = "EINTRAGUNGSLISTE_ID", referencedColumnName="EINTRAGUNGSLISTE_ID"))
  protected de.ivu.elect.business.unterstuetzer.entity.Eintragungsliste eintragungsliste;

  /**
   * 
   */
  @Override
  public void setEintragungsliste( de.ivu.elect.business.unterstuetzer.entity.Eintragungsliste eintragungsliste){
    resetTkCache();

    try {
      if (!updateRelationship){
        updateRelationship = true;

    

        if (eintragungsliste == null){
          // andere Seite der Beziehung aktualisieren wenn vorher nicht null
          if (this.eintragungsliste != null){
            this.eintragungsliste.removeEintragungslisteEintragByEintragungsliste(this);
          }
        } else {
          // andere Seite der Beziehung aktualisieren
          eintragungsliste.addEintragungslisteEintragByEintragungsliste(this);
        }
        this.eintragungsliste = eintragungsliste;
    
      }
    } finally {
      updateRelationship = false;
    }
  }


/**
* 
* Kein Update der bidirektionalen Beziehung - schneller, aber mit Vorsicht zu genießen
*/
@Override
public void setEintragungslisteOhneUpdateBeziehung( de.ivu.elect.business.unterstuetzer.entity.Eintragungsliste eintragungsliste){
    resetTkCache();
        this.eintragungsliste = eintragungsliste;
    }

  /**
   * 
   */
    @Override
  public de.ivu.elect.business.unterstuetzer.entity.Eintragungsliste getEintragungsliste(){
    return this.eintragungsliste;
  }

  /**
   * Beziehung N:1 (bidirektional) zu WahlvorschlagsPerson
   */
  @javax.persistence.ManyToOne(fetch =  javax.persistence.FetchType.LAZY , optional=true, cascade = {javax.persistence.CascadeType.PERSIST})
  @javax.persistence.JoinColumns(@javax.persistence.JoinColumn(name = "WAHLVORSCHLAGS_PERSON_ID", referencedColumnName="PERSONENDATEN_ID"))
  protected de.ivu.elect.business.wahlvorschlagsperson.entity.WahlvorschlagsPerson wahlvorschlagsPerson;

  /**
   * 
   */
  @Override
  public void setWahlvorschlagsPerson(@javax.annotation.Nullable  de.ivu.elect.business.wahlvorschlagsperson.entity.WahlvorschlagsPerson wahlvorschlagsPerson){
    resetTkCache();

    try {
      if (!updateRelationship){
        updateRelationship = true;

    

        if (wahlvorschlagsPerson == null){
          // andere Seite der Beziehung aktualisieren wenn vorher nicht null
          if (this.wahlvorschlagsPerson != null){
            this.wahlvorschlagsPerson.removeEintragungslisteEintragByWahlvorschlagsPerson(this);
          }
        } else {
          // andere Seite der Beziehung aktualisieren
          wahlvorschlagsPerson.addEintragungslisteEintragByWahlvorschlagsPerson(this);
        }
        this.wahlvorschlagsPerson = wahlvorschlagsPerson;
    
      }
    } finally {
      updateRelationship = false;
    }
  }


/**
* 
* Kein Update der bidirektionalen Beziehung - schneller, aber mit Vorsicht zu genießen
*/
@Override
public void setWahlvorschlagsPersonOhneUpdateBeziehung(@javax.annotation.Nullable  de.ivu.elect.business.wahlvorschlagsperson.entity.WahlvorschlagsPerson wahlvorschlagsPerson){
    resetTkCache();
        this.wahlvorschlagsPerson = wahlvorschlagsPerson;
    }

  /**
   * 
   */
  @javax.annotation.Nullable   @Override
  public de.ivu.elect.business.wahlvorschlagsperson.entity.WahlvorschlagsPerson getWahlvorschlagsPerson(){
    return this.wahlvorschlagsPerson;
  }


  /**
   * Beziehungen 1:N unidirektional (nicht unterstuetzt)
   */

  /**
   * Beziehungen 1:N bidirektional
   */

  /**
   * Beziehungen N:M bidirektional nicht selbstreferenzierend
   */


  /**
   * Beziehungen N:M bidirektional selbstreferenzierend
   */
  

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("EintragungslisteEintrag:");
    sb.append(getId());
    sb.append(" (TK: ");
    try {
      sb.append(getTk());
    } catch (Exception e) {
      sb.append(e.getMessage());
    }
    sb.append(")");
    return sb.toString();
}



  /**
   * Kopiert alle Attribute (ausser PK und Version) und UNIDIREKTIONALE n:1-Beziehungen in uebergebene Entitaet.
   *
   * @param other
   *
   * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
   *             als Deprecated.
   */
  @Deprecated
  protected void copyEntity(EintragungslisteEintrag other){
                             other.erfassungZeitpunkt = this.erfassungZeitpunkt;
                                other.gueltigkeit = this.gueltigkeit;
                                other.position = this.position;
           
  other.setEintragungsliste(this.getEintragungsliste());
  other.setWahlvorschlagsPerson(this.getWahlvorschlagsPerson());
    if (this.transientContext != null && !this.transientContext.isEmpty()) {
      other.getTransientContext().putAll(this.transientContext);
    }
  }



    @Override
    public void copyEntityAttributesToOtherEntity(de.ivu.elect.jee.entity.Entity other) {
      if (other==null){
        return;
      }
      if (other.isInstanceOf(EintragungslisteEintrag.class)){
        copyEntityAttributesUsingSetter((EintragungslisteEintrag) other.castTo(EintragungslisteEintrag.class).getEntity());
      } else {
        throw new IllegalArgumentException("Keine Instanz von EintragungslisteEintrag: " + other);
      }
    }

  /**
  * Kopiert alle Attribute (ausser PK und Version)  in uebergebene Entitaet.
  *
  */
  public void copyEntityAttributesUsingSetter(EintragungslisteEintrag other){
               other.setErfassungZeitpunkt(this.erfassungZeitpunkt);
                  other.setGueltigkeit(this.gueltigkeit);
                  other.setPosition(this.position);
           if (this.transientContext != null && !this.transientContext.isEmpty()) {
      other.getTransientContext().putAll(this.transientContext);
    }
  }


  /**
   * Kopiert alle veränderten Attribute (ausser PK, CustomData, wenn vorhanden und Version) in uebergebene Entitaet.
   *
   */
  public void copyChangedEntityAttributesUsingSetter(EintragungslisteEintrag other){
                       if (hasChangedErfassungZeitpunkt) {
        other.setErfassungZeitpunkt(this.erfassungZeitpunkt);
      }
                             if (hasChangedGueltigkeit) {
        other.setGueltigkeit(this.gueltigkeit);
      }
                             if (hasChangedPosition) {
        other.setPosition(this.position);
      }
             }





    @javax.persistence.Transient
    private transient EintragungslisteEintragTK tkCache;

    protected void resetTkCache() {
        tkCache = null;
    }

    public EintragungslisteEintragTK getEintragungslisteEintragTK(){
    if (tkCache==null) {
    tkCache = new EintragungslisteEintragTK(



  );}
  return tkCache;
}
    @Override
    public de.ivu.elect.jee.entity.tk.EntityTK getTk() {
       return getEintragungslisteEintragTK();
    }

  @Override
  public EintragungslisteEintragUK getUk(){
    return getEintragungslisteEintragUK();
  }

  @Override
  public Class< ? > getEntityClass() {
    return EintragungslisteEintrag.class;
  }

public EintragungslisteEintragUK getEintragungslisteEintragUK(){

   return  new EintragungslisteEintragUK(



  );
}

  @javax.persistence.Transient
  private transient EintragungslisteEintragProperties properties;

  public EintragungslisteEintragProperties getProperties(){
    if (properties == null) {
      properties = new EintragungslisteEintragProperties(this);
    }
    return properties;
  }

  /**
   * @deprecated getProperties() verwenden.
   */
  @Deprecated
  public EintragungslisteEintragProperties getEintragungslisteEintragProperties(){
    return getProperties();
  }

  @Override
  public String getEntityTechnicalName() {
    return EintragungslisteEintragConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public boolean isAenderungenProtokollieren(){
    
    return true;
  }


    @Override
   public void setProtokollierteAttributeMitWerten(java.util.Map<String, de.ivu.elect.jee.protokollierung.AttributWertVorher> werteVorher) {
     
      if (werteVorher.containsKey(EintragungslisteEintragConstants.MESSAGE_KEY_ERFASSUNG_ZEITPUNKT_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(EintragungslisteEintragConstants.MESSAGE_KEY_ERFASSUNG_ZEITPUNKT_EINZAHL);

        erfassungZeitpunkt =
     vorher.getAttributTyp().getValueAsDate(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(EintragungslisteEintragConstants.MESSAGE_KEY_GUELTIGKEIT_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(EintragungslisteEintragConstants.MESSAGE_KEY_GUELTIGKEIT_EINZAHL);

        gueltigkeit =
     (de.ivu.elect.business.unterstuetzer.entity.EintragungslisteEintragGueltigkeit) vorher.getAttributTyp().getValueAsEnum(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(EintragungslisteEintragConstants.MESSAGE_KEY_POSITION_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(EintragungslisteEintragConstants.MESSAGE_KEY_POSITION_EINZAHL);

        position =
                        vorher.getAttributTyp().getValueAsLong(vorher.getWertVorher());
                  }

                }

  @Override
  public java.util.Map<String, de.ivu.elect.jee.protokollierung.VorherNachherWert> getProtokollierteAttributeMitWerten() {
    java.util.Map<String,de.ivu.elect.jee.protokollierung.VorherNachherWert> result;
        result = createEmptyProtokollierteAttributeMitWertenMap();
                        if (isSeitLadenVeraendertErfassungZeitpunkt) {
      result.put(EintragungslisteEintragConstants.MESSAGE_KEY_ERFASSUNG_ZEITPUNKT_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.TIMESTAMP
                , wertNachLadenErfassungZeitpunkt , erfassungZeitpunkt));
    }
                            if (isSeitLadenVeraendertGueltigkeit) {
      result.put(EintragungslisteEintragConstants.MESSAGE_KEY_GUELTIGKEIT_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.ENUM
                , wertNachLadenGueltigkeit , gueltigkeit));
    }
                            if (isSeitLadenVeraendertPosition) {
      result.put(EintragungslisteEintragConstants.MESSAGE_KEY_POSITION_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
                                    de.ivu.elect.jee.protokollierung.AttributTyp.LONG
                            , wertNachLadenPosition , position));
    }
                return result;
  }

  @Override
  public void resetProtokollierteAttribute() {
                      isSeitLadenVeraendertErfassungZeitpunkt = false;
      wertNachLadenErfassungZeitpunkt = null;
                          isSeitLadenVeraendertGueltigkeit = false;
      wertNachLadenGueltigkeit = null;
                          isSeitLadenVeraendertPosition = false;
      wertNachLadenPosition = null;
                   }

  @Override
  public  java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> getFachlichAbhaengigeEntitaeten(){
            java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> result = new java.util.ArrayList<>();
                            return result;
  }

        
            protected String getInitialDiscriminator() {
              return "EINTRAGUNGSLISTE_EINTRAG";
            }

            @Override
            public boolean isInstanceOf(Class<?> clazz) {
            return clazz.isInstance(this);
            }


            @Override
            public <E> de.ivu.elect.jee.entity.EntityContainer<E> castTo(Class<E> clazz) {
                return new de.ivu.elect.jee.entity.EntityContainer<>((E)this); // EntityContainer ist notwendig, da sonst von Hibernate die Entität wieder durch ihren Proxy ersetzt wird...
            }

  public boolean isPersistent() {
    return getId() != null;
  }


   private static final String BASE_CLASS_NAME = "EintragungslisteEintrag";
   @Override
   public String getBaseClassName() {
     return BASE_CLASS_NAME;
   }


    @Override
    public boolean equals(Object obj) {
    if (obj == null) {
    return false;
    }

    if (this==obj) {
    return true;
    }


    if (id != null) {
      try {
        return id.longValue() == ((de.ivu.elect.jee.entity.Entity) obj).getId().longValue() && BASE_CLASS_NAME.equals(((de.ivu.elect.jee.entity.Entity) obj).getBaseClassName());
      } catch (Exception ignored) {
        // do nothing
        return false;
      }
    }
   return super.equals(obj);
    }

  @javax.persistence.Transient
  private transient boolean hashCodeBerechnet = false;

  @javax.persistence.Transient
  private transient int hashCode = 0;


  @Deprecated // nur in Unit-Tests verwenden(!)
  public void resetHashCode() {
    hashCodeBerechnet = false;
    hashCode = 0;
  }

  @Override
    public int hashCode() {
      if (hashCodeBerechnet) {
      return hashCode;
    }

    if (id == null) {
      hashCode = super.hashCode();
    } else {
      hashCode = id.hashCode();
    }

    hashCodeBerechnet = true;

    return hashCode;

    }


                            @javax.persistence.Transient
                private transient java.util.Set
            <String> dirtyProperties = null;

                protected void markDirty(String property) {
            
          }

          public java.util.Set
      <String> getDirtyProperties() {
          if (dirtyProperties==null){
          dirtyProperties = new java.util.HashSet<>();
          }
          return dirtyProperties;
          }

          public void clearDirtyProperties(){
          dirtyProperties = null;
          }
          public boolean isHibernateDirty() {
            return dirtyProperties!=null;
          }

      
                public void resetValidation() {
        
    validationResult = null;
        }

        @javax.persistence.Transient
        private transient java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validationResult;

                    public java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validateEntity() {
            if (validationResult==null) {
               validationResult  = new java.util.HashSet<>();
                                                                                                                            de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(gueltigkeit, this, EintragungslisteEintragConstants.MESSAGE_KEY_GUELTIGKEIT_EINZAHL, validationResult);
                                                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(position, this, EintragungslisteEintragConstants.MESSAGE_KEY_POSITION_EINZAHL, validationResult);
                                                                          de.ivu.elect.jee.entity.EntityConstraintCheck.checkValueRange(EintragungslisteEintragConstants.POSITION_MAX_VALUE, EintragungslisteEintragConstants.POSITION_MIN_VALUE, position, this, EintragungslisteEintragConstants.MESSAGE_KEY_POSITION_EINZAHL, validationResult);
                                    }
             return validationResult;
        }

            
        @javax.persistence.Transient
        protected transient java.util.Map<String, Object> transientContext;

        @Override
        public java.util.Map<String, Object> getTransientContext() {
          if (transientContext == null) {
             transientContext = new java.util.HashMap<>();
          }
        return transientContext;

        }
                              }
